TaskTracker/Components/NavbarViewComponent.cs
using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using TaskTracker.Core;
using TaskTracker.Core.Domain;
using TaskTracker.Helpers;
using TaskTracker.Models;
using TaskTracker.Service.Services;

namespace TaskTracker.Components
{
    public class NavbarViewComponent : ViewComponent
    {
        #region Fields
        private readonly IMapper _mapper;
        private readonly IWorkspaceService _workspaceService;
        private readonly IProjectService _projectService;
        private readonly IWorkContext _workContext;
        private readonly IHttpContextAccessor _httpContextAccessor;
        private readonly IPermissionHelper _permissionHelper;
        #endregion

        #region Ctor
        public NavbarViewComponent(
            IMapper mapper,
            IWorkspaceService workspaceService,
            IProjectService projectService,
            IWorkContext workContext,
            IHttpContextAccessor httpContextAccessor,
            IPermissionHelper permissionHelper)
        {
            _mapper = mapper;
            _workspaceService = workspaceService;
            _projectService = projectService;
            _workContext = workContext;
            _httpContextAccessor = httpContextAccessor;
            _permissionHelper = permissionHelper;
        }
        #endregion

        #region Public Methods
        public async Task<IViewComponentResult> InvokeAsync()
        {

            var user = await _workContext.GetCurrentUserAsync();
            if (user == null)
            {
                _httpContextAccessor.HttpContext.Response.Redirect("/Account/login");
                return View(new BaseViewModel());
            }
            var workspaceId = await _workContext.GetCurrentWorkspaceIdAsync();
            var workspace = await _workspaceService.GetWorkspaceDetailsAsync(workspaceId);

            var projects = await _projectService.GetProjectListByWorkspace(workspaceId);
            var model = new BaseViewModel
            {
                User = _mapper.Map<AppUserModel>(user),
                Workspace = _mapper.Map<WorkspaceModel>(workspace),
                Projects = _mapper.Map<List<ProjectModel>>(projects),
                Permissions = SetUserAccessRights(workspace)
            };

            return View(model);
        }


        #endregion

        #region Private Methods
        private RolePermissionModel SetUserAccessRights(Workspace workspace)
        {
            var permission = _permissionHelper.SetUserAccessRightsByWorkspace(workspace);
            var model = _mapper.Map<RolePermissionModel>(permission);
            return model;
        }
        #endregion
    }
}

TaskTracker/Views/Shared/NotFound.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

TaskTracker/Views/Shared/_AccessDenied.cshtml
@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
}

TaskTracker/Views/Shared/_CommonComponents.cshtml
@await Html.PartialAsync("~/Views/Project/_CreateProject.cshtml")
@await Html.PartialAsync("~/Views/Workspace/_CreateWorkspace.cshtml")
<div class="modal-container"></div>
<div class="overlay" style="display: none">
    <div class="spinner-container d-flex justify-content-center align-items-center">
        <div class="spinner-grow" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-primary" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-secondary" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-success" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-danger" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-warning" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-info" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-light" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
        <div class="spinner-grow text-dark" role="status">
            <span class="visually-hidden">Loading...</span>
        </div>
    </div>
</div>

TaskTracker/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - TaskTracker</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/notyf@3/notyf.min.css">
    <link rel="stylesheet" href="~/lib/font-awesome/css/all.min.css" />
    @* <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" /> *@
    <link href="~/lib/jqueryui/themes/base/jquery-ui.min.css" rel="stylesheet" />
    <link rel="stylesheet" href="~/css/theme.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
</head>
<body data-layout=vertical data-sidebartype="full">
    <div id="main-wrapper">
        <aside class="left-sidebar with-vertical">
            <div>
                <div class="brand-logo d-flex align-items-center justify-content-between">
                    <a asp-controller="home" asp-action="index" class="text-nowrap logo-img">
                        <img src="/images/dark-logo.png" class="dark-logo" alt="Logo-Dark">
                    </a>
                </div>
            </div>
        </aside>
        <div class="page-wrapper">
            @await Component.InvokeAsync("Navbar")
        </div>
        <div class="body-wrapper">
            <div class="container-fluid">
                @RenderBody()
            </div>
        </div>
    </div>
    <div class="common-view">
        @await Html.PartialAsync("_CommonComponents")
    </div>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/jquery-ajax-unobtrusive/jquery.unobtrusive-ajax.min.js"></script>
    <script src="~/lib/jquery-validation/dist/jquery.validate.js"></script>
    <script src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/notyf@3/notyf.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/6.0.0/bootbox.js"></script>
    <script src="~/lib/jqueryui/jquery-ui.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

TaskTracker/Views/Shared/_NoSidebar.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - TaskTracker</title>
    <link rel="stylesheet" href="~/lib/font-awesome/css/all.min.css" />
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/theme.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
</head>
<body data-sidebartype="full">
    <div>
        @RenderBody()
    </div>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>

TaskTracker/Views/Shared/_UserAvatar.cshtml
@model AppUserModel

@{
    var size = ViewData["_size"] ?? "30";
}
@if(Model != null)
{
    if (!string.IsNullOrEmpty(Model.PictureUrl))
    {
        <img src="@Model.PictureUrl" title="@Model.Name (@Model.Email)" class="rounded-circle img-avatar" width="@size" height="@size" alt="">

    }
    else
    {
        <img src="/images/placeholder-profile.jpg" title="@Model.Name (@Model.Email)" class="rounded-circle img-avatar" width="@size" height="@size" alt="">
    }
}
else
{
    <img src="/images/placeholder-profile.jpg" class="rounded-circle img-avatar" width="@size" height="@size" alt="">
}